// vim600:fdm=marker
#include <fcntl.h>
#ifdef __cplusplus
extern "C" {
#endif
#include "md4.h"
#ifdef __cplusplus
	}
#endif

#include "donkey.h"
#include "misc.h"
#include "sFile.h"
#include "sGui.h"
#include "sSource.h"
#include "sTag.h"
#include "misc.h"

#include "protocol.h"
#include "cygwin.h"
#include "opcodes.h"

int    sFile::count      = 0;
int    sFile::count_complete  = 0;
sFile *sFile::first_file = NULL;

void sFile::Init(void) {{{
	this->pause		= 0;
	this->part_defekt	= NULL;
	this->ul_last   	= 0;
    	this->dl_last   	= 0;
    	this->ul_count  	= 0;
    	this->dl_count  	= 0;
    	this->ul_rate   	= 0.0;
    	this->dl_rate   	= 0.0;
    	this->search_count 	= 0;
	this->compress_failed 	= 0;
	this->transfered 	= 0;
	this->downloads  	= 0;
	this->publish_next 	= 0;
	this->db2 		= NULL;
	this->fd_in 		= -1 ;
	this->name		= NULL;
	this->temp		= NULL;
	this->part_count	= 0;
	this->part_hash  	= NULL;
	this->part_status 	= NULL;
	this->part_sources	= NULL;
	next_file  = NULL;
	count++;
	if (first_file == NULL) first_file = this;
	else {{{
		class sFile *akt = first_file;
		while (akt->next_file != NULL) akt=akt->next_file;
		akt->next_file = this;
		}}}
	}}}
void sFile::Init2 (void) {{{
	force_met = currentTime;
	if (this->part_status == NULL) {
		this->part_status  = (uint8_t*)MALLOC ((part_count+7)/8);
		memset (part_status , 0, (part_count+7)/8);
		}
	if (this->part_defekt == NULL) {
		this->part_defekt  = (uint8_t*)MALLOC ((part_count+7)/8);
		memset (part_defekt , 0, (part_count+7)/8);
		}
	this->part_sources = (size_t *)MALLOC (part_count * sizeof(size_t));
	memset (part_sources, 0, part_count * sizeof(size_t));
	}}}
bool sFile::Metfile_load(char *buf, size_t len, const char *dir) {{{
	if (buf == NULL) return false;
	if (dir == NULL) return false;
	uint8_t  version 	= GET_U1 (&buf, &len);
	time_t   date    	= GET_U4 (&buf, &len);
	char dateiname[512];
	strftime(dateiname, 512, "%Y.%m.%d %H:%M.%S", gmtime(&date));
	GET_HASH (&buf, &len, hash);
	printf("Version vom %s for %s\n", dateiname, hash_bin2hex(hash));
	part_count = GET_U2 (&buf, &len);
	sprintf (dateiname, "%s%c%s.db2", control, dir_delim, hash_bin2hex (hash));
	db2 = initBtree (dateiname);

	dtype d;
	d.disk  = 0;
	d.since = 0;
	d.von 	= 0;
	d.bis 	= size - 1;
	d.stat  = 2000;
	Change_range(db2, d);

	if (part_count != 0) {
		part_hash = (tHash *)MALLOC (part_count * sizeof (tHash));
		memcpy(part_hash, buf, part_count * 16);
		buf += part_count * 16;
		len -= part_count * 16;
		}
	class sTag *tag = parse_tag (buf, &len);
	if (tag == NULL) return false;
	if (tag->name != NULL) {{{
		if (name != NULL) free(name);
		name = tag->name;
		tag->name = NULL;
		}}}
	if (0 != tag->size	 ) size = tag->size;
	if (0 != tag->transfered ) transfered = tag->transfered;
	if (0 != tag->dl_prio    ) dl_prio    = tag->dl_prio;
	if (0 != tag->corrupt_len) {
		if (tag->corrupt_len == (part_count+7)/8) {
			if (this->part_defekt != NULL) free (this->part_defekt);
			this->part_defekt = tag->corrupt_dat;
			tag->corrupt_dat = NULL;
			tag->corrupt_len = 0;
			}
		}
	if (0 != tag->temp       ) {{{
		temp = STRDUP (tag->temp);
		snprintf(dateiname, 512, "%s%c%s", dir, dir_delim, tag->temp);
		if (all_done   ) fd_in = FD_open (dateiname, O_RDONLY|O_BINARY);
		if (fd_in == -1) fd_in = FD_open (dateiname, O_RDWR|O_BINARY);
		if (fd_in == -1) fd_in = FD_open (dateiname, O_CREAT|O_RDWR|O_BINARY, 0600);
		}}}
	for (tGap_map::iterator gap = tag->gap_map.begin(); gap != tag->gap_map.end(); gap++) {{{
		d.von 	= (*gap).second.von;
		d.bis 	= (*gap).second.bis - 1;
		if (d.von > size && d.bis > size) continue;
		if (d.bis >= size) d.bis = size - 1;
		if (d.von > d.bis ) d.von = d.bis;
		d.stat  = 0;
		Change_range(db2, d);
		}}}
	delete tag;
	if (part_count == 0) part_count = (size + PARTSIZE - 1) / PARTSIZE;
	ASSERT (version == 0xE0);
	if (part_count != (size + PARTSIZE - 1) / PARTSIZE) {
		printf("%u != %u\n", part_count, (size + PARTSIZE - 1) / PARTSIZE);
		printf("Size %9u\n", size);
		printf("Hash %s\n", hash_bin2hex(hash));
		}
	ASSERT (part_count == (size + PARTSIZE - 1) / PARTSIZE);
	return true;
	}}}
sFile     ::sFile (const char *met, const char *dir) {{{
	Init ();
	this->all_done = (0 != strcmp(dir, incoming));
	size_t LEN = 0;
	char *BUF = file (met, &LEN);
	if (BUF == NULL) return;
	Metfile_load (BUF, LEN, dir);
	free (BUF);
	Init2 ();
	if (!all_done) {
		this->status = HASHING;
		fastCheck    (0, size);
		printf("DONE: ");
		size_t i = 0;
		for (i = 0; i < partCount(); i++) printf("%c", (partStatus(i)?'1':'0'));
		printf("\n");
		printf("BAD : ");
		for (i = 0; i < partCount(); i++) printf("%c", (partDefekt(i)?'1':'0'));
		printf("\n");
		if (this->status != ALL_DONE) this->status = NAME_KNOWN;
		}
	else	{
		for(uint32_t i=0; i < partCount(); i++) partStatus(i, true);
		this->status = ALL_DONE;
		count_complete++;
		}
	char dateiname[512];
	snprintf(dateiname, 512, "%s%c%s.part.met", control, dir_delim, hash_bin2hex(hash));
	if (0 != strcmp(met, dateiname)) rename(met, dateiname);
	}}}
sFile     ::sFile (const unsigned char HASH[16], const char *NAME, unsigned int SIZE, const char *dir) {{{
	Init();
	this->all_done 		= (0 != strcmp(dir, incoming));
	this->size   	 	= SIZE;
	this->part_count 	= (size + PARTSIZE - 1) / PARTSIZE;
	this->name   	 	= STRDUP (NAME);
	this->temp		= STRDUP (NAME);
	this->status 		= NAME_KNOWN;
	memcpy (this->hash, HASH, 16);
	Init2 ();
	log (1,"= ed2k://|file|%s|%u|%s|\n", this->name, this->size, hash_bin2hex (this->hash));
	Save (dir);
	if (part_hash == NULL) loadPartHash ();
    	size_t in_len = strlen(dir)+1+strlen(name)+1;
  	char *in_name = (char*)MALLOC (in_len);
  	sprintf(in_name, "%s%c%s", dir, dir_delim, name);
	if (!all_done) {{{ // file not finished
	  	if (fd_in == -1) fd_in = FD_open (in_name, O_RDWR|O_BINARY);
	  	if (fd_in == -1) fd_in = FD_open (in_name, O_CREAT|O_RDWR|O_BINARY, 0600);
	  	if (SIZE > 1024 * 1024 * 10) ftruncate(fd_in, SIZE);
     	 	this->status = HASHING;
      		fastCheck    (0, size);
      		if (this->status != ALL_DONE) this->status = NAME_KNOWN;
		}}}
	else  {{{		// file aleady completed
	  	if (fd_in != -1) fd_in = FD_open (in_name, O_RDONLY|O_BINARY);
	  	ASSERT ( fd_in >= 0 );
	  	for(uint32_t i=0; i < partCount(); i++) partStatus(i, true);
      		this->status = ALL_DONE;
	  	count_complete++;
		}}}
	Free2 (in_name);
	Sync ();
	printf("* ed2k://|file|%s|%u|%s|\n", this->name, this->size, hash_bin2hex (this->hash));
	if (1 == (pref.verbose & 1)) {{{
		printf("Status: ");
		for(uint32_t i=0; i < partCount(); i++) printf("%c", partStatus(i)?'1':'0');
		printf("\n");
		}}}
	GUI_LIST {{{
		if (!all_done) 	akt->GUI_new_download(this);
				akt->GUI_new_upload  (this);
		}}}
	}}}
sFile     ::~sFile (void) {{{
	tHash hash_set;
	bzero(hash_set, 16);
	SOURCE_LIST if (akt->dl_file == this) akt->dlFile(hash_set);
//	for (const dtype *akt_part = firstBlock(); akt_part != NULL; akt_part = nextBlock()) ;	WHY THIS ?
	PartMet_write ();
	Sync();
	{ GUI_LIST akt->GUI_removeDownload (hash); }
	if (name        != NULL) Free2 (name);
	if (part_hash   != NULL) Free2 (part_hash);
	if (part_status != NULL) Free2 (part_status);
	if (part_defekt != NULL) Free2 (part_defekt);
	if (part_sources!= NULL) free  (part_sources);
	FD_close (fd_in );
	if (db2 != NULL) closeBtree (db2);
	if (first_file == this) {	// remove me from the file_list
		first_file = next_file;
		return;
		}
	sFile *prev_file = first_file;
	while (prev_file->next_file != this && prev_file->next_file != NULL)
		prev_file = prev_file->next_file;
	ASSERT (prev_file != NULL);
	ASSERT (prev_file->next_file == this);
	prev_file->next_file = prev_file->next_file->next_file;
	count--;
	}}}
void         sFile::PartMet_write   (void) {{{
	force_met = currentTime;
	char buffer[4096];
	size_t len, LEN = len = 4096;
	char *buf, *BUF = buf = buffer;
	ADD_U1(&buf, &len, 0xE0);
	ADD_U4(&buf, &len, currentTime);
	ADD_HASH(&buf, &len, hash);
	if (havePartHash()) {{{
		ADD_U2(&buf, &len, part_count);
		for (size_t i = 0; i < part_count; i++) {
			ADD_HASH(&buf, &len, *getPartHash(i));
			}
		}}}
	else	{{{
		ADD_U2(&buf, &len, 0);
		}}}
	size_t	tagCount = 5;
	char *tag_pos = buf;
	size_t tag_len = len;
	ADD_U4     (&buf, &len, 0);			// changed later
	if (name != NULL) { add_strTag (&buf, &len, FT_FILENAME	, name); tagCount++; }
	add_intTag (&buf, &len, FT_FILESIZE	, size);
	add_intTag (&buf, &len, FT_TRANSFERED	, transfered);	
	if (name != NULL) { add_strTag (&buf, &len, FT_PARTFILENAME	, name); tagCount++; }
	add_intTag (&buf, &len, FT_DLPRIOTITY	, 1);		// TODO
	add_intTag (&buf, &len, FT_STATUS	, 0);		// evtl TODO
	add_bobTag (&buf, &len, "corrupt", (char*)part_defekt, (part_count+7)/8);
	size_t gap_idx = 0;
	for (const dtype *akt_part = firstBlock(); akt_part != NULL; akt_part = nextBlock()) {{{
		if (akt_part->stat == BLOCK_LOCALE) continue;
		char tag[20];
		snprintf(tag, 20, "%c%u",  9, gap_idx);
		add_intTag(&buf, &len, tag, akt_part->von);
		snprintf(tag, 20, "%c%u", 10, gap_idx);
		add_intTag(&buf, &len, tag, akt_part->bis+1);
//		printf("GAP %9u-%9u\n", akt_part->von, akt_part->bis);
		gap_idx++;
		tagCount += 2;
		}}}
	ADD_U4     (&tag_pos, &tag_len, tagCount);

	char dateiname0[512];
	char dateiname1[512];
	char dateiname2[512];
	snprintf(dateiname0, 512, "%s%c%s.part.set", control, dir_delim, hash_bin2hex (hash));
	snprintf(dateiname1, 512, "%s%c%s.part.met", control, dir_delim, hash_bin2hex (hash));
	snprintf(dateiname2, 512, "%s%c%s.part.old", control, dir_delim, hash_bin2hex (hash));
	int fd = FD_open (dateiname0, O_CREAT|O_TRUNC|O_WRONLY|O_BINARY,0600);
	if (fd == -1) return;
	int to_write = LEN - len;
	FD_WRITE (fd, BUF, to_write);
	close (fd);
	remove(dateiname2);
	if (0 != rename(dateiname1, dateiname2)) {
		if (errno != 2)
			printf("sFile 277 met -> old failed %4i %s\n", errno, strerror(errno));
		}
	if (0 != rename(dateiname0, dateiname1)) {
		printf("sFile 280 set -> met failed %4i %s\n", errno, strerror(errno));
		abort();
		return;
		}
	}}}
int          sFile::Save            (const char *dir) {{{
	char dateiname[512];
	snprintf(dateiname, 512, "%s%c%s.part.met", control, dir_delim, hash_bin2hex (hash));
	size_t	LEN;
	char *BUF = file (dateiname, &LEN);
	if (BUF != NULL) {
		Metfile_load (BUF, LEN, dir);
		free (BUF);
		}

	char *filename = (char*)MALLOC (strlen(control) + 1 + sizeof(hash)*2 + strlen(".lst") + 1);
	sprintf (filename, "%s%c%s.lst", control, dir_delim, hash_bin2hex (hash));
	int fd_tre = FD_open (filename, O_RDWR|O_BINARY);
	if (fd_tre == -1) {{{ // Create new LST file.
		fd_tre = FD_open (filename, O_CREAT|O_RDWR|O_BINARY, 0600);
	  	if (fd_tre < 0) {
			ASSERT(0);
			return -1;
		  	}
		size_t len = strlen(name);
	  	FD_LSEEK (fd_tre, 0, SEEK_SET);
	  	FD_WRITE (fd_tre, (char*)&size,   4);
	  	FD_WRITE (fd_tre, (char*)hash ,  16);
	  	FD_WRITE (fd_tre, (char*)&len ,   4);
	  	FD_WRITE (fd_tre, name , len);
	  	FD_WRITE (fd_tre, (char*)&pause, 1);
		}}}
  	FD_close(fd_tre);
	Free2 (filename);
	filename = NULL;

	if (all_done) return 0;
	if (db2 != NULL) return 0;
	filename = (char*)MALLOC (strlen(control) + 1 + sizeof(hash)*2 + strlen(".db2") + 1);
	sprintf (filename, "%s%c%s.db2", control, dir_delim, hash_bin2hex (hash));
	db2 = initBtree (filename);
	loadBtree (db2, 0, 4 + 16 + 4 + strlen(name), size);
	Free2 (filename);
	return 0;
	}}}
void         sFile::Pause           (int p) {{{
	if (pause == p ) return ;
	pause = p;
//	SaveStatus(); // Save new Status in .lst
	tHash zero;
	bzero (zero, 16);
	if ( pause != 1 ) return;
	SOURCE_LIST 			// remove current dl sources
		if (this == akt->dl_file ) 
			akt->dlFile(zero); // it only interest if WE are the dlFile not what file it is
	}}}
bool         sFile::loadPartHash    (void) {{{ // ONLY for *.lst
	if(part_hash!=NULL) return true;
	size_t tmp_len = strlen(control)+1+32+5+1;
	char *tmp_name = (char*)MALLOC (tmp_len);
	sprintf(tmp_name, "%s%c%s.hash", control, dir_delim, hash_bin2hex (hash));
	int fd = FD_open (tmp_name, O_RDONLY|O_BINARY);
	Free2 (tmp_name);
	if (fd<0) return false;
	part_hash = (tHash *)MALLOC (part_count * sizeof (tHash));
        MD4_CTX ctx;
        MD4Init   (&ctx);
	FD_READ (fd, (char*)part_hash, sizeof(tHash) * part_count);
	for (uint32_t i = 0; i < part_count; i++) {
		MD4Update (&ctx, (unsigned char*) getPartHash(i), sizeof(tHash));
		}
	FD_close (fd);
	uint8_t hash_test[16];
	hash_test[0]=0;
	MD4Final  (hash_test, &ctx);
	memcmp (hash_test, hash, 16);
//	if ( hash_test[0] == 0 ) ASSERT(0);
	//if ( 0 == (memcmp (hash_test, hash, 16)) ) ASSERT(0);
	printf("Part hash %32s succesfully loaded\n", hash_bin2hex (hash) );
	return true;
	}}}
bool         sFile::savePartHash    (tHash *hashset) {{{
	if (part_hash != NULL) return false;
	part_hash = hashset;
	char *buf = (char*)MALLOC (strlen(control)+39);
	sprintf(buf, "%s%c%32s.hash", control, dir_delim, hash_bin2hex (hash));
	int fd = FD_open (buf, O_CREAT|O_WRONLY|O_BINARY, 0600);
	Free2 (buf);
	ASSERT (fd >=0);
	FD_LSEEK (fd, 0, SEEK_SET);
	int tmp = 16 * part_count;
	FD_WRITE (fd, (char*)part_hash, tmp);
	FD_close (fd);
	return true;
	}}}
tHash*       sFile::getPartHash     (uint32_t i) const {{{
static  tHash hash_tmp;
	memcpy(hash_tmp, hash, 16);
	if (Size()<PARTSIZE) return &hash_tmp;
	ASSERT (part_hash!=NULL && i<part_count);
	return part_hash+i; 
	}}}

#ifdef FASTHASH
bool fast_hash = 1;
#else
bool fast_hash = 0;
#endif
void         sFile::partStatus      (uint32_t idx, bool set) {{{
	int pos = idx / 8;
	int off = idx & 7;
	if (idx >= part_count) return;
	partDefekt(idx, !set);
	uint8_t mask = 0xff ^ (1 << off);
	uint8_t flag = (set)? (1 << off) : 0;
	part_status [pos] = (part_status [pos] & mask) | flag;
	}}}
bool         sFile::partStatus      (uint32_t idx) const {{{
	ASSERT (part_status != NULL);
	int pos = idx / 8;
	uint8_t off = ((uint8_t)idx & 7);
	if (idx >= part_count) return 0;
	uint8_t flag = (1 << off);
	return  (part_status [pos] & flag) != 0;
	}}}
void         sFile::partDefekt      (uint32_t idx, bool set) {{{
	int pos = idx / 8;
	int off = idx & 7;
	if (idx >= part_count) return;
	uint8_t mask = 0xff ^ (1 << off);
	uint8_t flag = (set)? (1 << off) : 0;
	part_defekt [pos] = (part_defekt [pos] & mask) | flag;
	}}}
bool         sFile::partDefekt      (uint32_t idx) const {{{
	ASSERT (part_defekt != NULL);
	int pos = idx / 8;
	uint8_t off = ((uint8_t)idx & 7);
	if (idx >= part_count) return 0;
	uint8_t flag = (1 << off);
	return  (part_defekt [pos] & flag) != 0;
	}}}

// Functions that take care of part Status
int          sFile::checkPart       (uint32_t akt_part) {{{
	if (partStatus(akt_part)) return 1;
	if (status == HASHING && fast_hash) {
		if (partDefekt (akt_part)) return false;
		partStatus(akt_part, true);
		return 1;
		}
	ASSERT (fd_in >= 0);
	if(!havePartHash()) return 0;
	int len = PARTSIZE;
	if (len + akt_part * PARTSIZE > Size()) len = Size() - akt_part * PARTSIZE;
	if (akt_part >= part_count) return 0;
	if (len<=0) return 0;
	char *map = (char*) MALLOC (len);
	FD_LSEEK (fd_in, akt_part * PARTSIZE, SEEK_SET);
	FD_READ (fd_in, map, len);
	bool ok = false;
	if (map != NULL) {{{
		MD4_CTX      ctx;
		MD4Init   (&ctx);
		MD4Update (&ctx, (unsigned char*)map, len);
		uint8_t tmp_hash[16];
		MD4Final (tmp_hash, &ctx);
		if (0 == memcmp (getPartHash (akt_part), tmp_hash, 16)) ok = true;
		Free2 (map);
		}}}
	if (ok) { 
		partStatus(akt_part, true);
		unsigned int OK = 0;
		for (unsigned int i = 0; i < part_count; i++)
			if (partStatus(i)) OK++;
		if (OK == part_count) {{{
			/* dl finished. Rename control* and incoming* */
			status = ALL_DONE;
			Sync();
			this->Completed(true) ;
			count_complete++ ;
           		 printf("Moving finished file %s to %s/ . YIHAA :)\n", this->name, completed );
			GUI_LIST { 
				akt->GUI_removeDownload(this->hash);
				akt->GUI_shareFiles();
				}
		    	char *alt = (char*)MALLOC (strlen(control) + 38);
		    	char *neu = (char*)MALLOC (strlen(control) + 48);
    			sprintf (alt, "%s%c%s.lst"    , control, dir_delim, hash_bin2hex (this->hash));
    			sprintf (neu, "%s%c%s.lst.completed", control, dir_delim, hash_bin2hex (this->hash));

			char *dateiname_neu = (char*)MALLOC (strlen (completed) + 1 + strlen (this->name) + 1);
            		char *dateiname_alt = (char*)MALLOC (strlen (incoming) + 1 + strlen (this->name) + 1);
            		/* Perhaps need to escape special chars ? */ 
            		sprintf (dateiname_neu, "%s%c%s", completed, dir_delim, this->name);
            		sprintf (dateiname_alt, "%s%c%s", incoming, dir_delim, this->name);

    			if ( rename(alt, neu) != 0 ) {
				printf("ERROR moving file %s to %s [%s]\n", alt, neu, strerror(errno) );
				}
    			Free2 (neu); 
   	 		Free2 (alt); 
			if ( rename(dateiname_alt,dateiname_neu) != 0 ) {
				printf("ERROR moving completed file %s to %s [%s]\n", dateiname_alt, dateiname_neu, strerror(errno) );
//				ASSERT(0);
				}
			Free2 (dateiname_neu);
			Free2 (dateiname_alt);
			}}}
		printf("%s [%2u]OK :-)\n", hash_bin2hex(hash), akt_part);
		dtype r;
		r.von   = (akt_part+0) * PARTSIZE;
		r.bis   = (akt_part+1) * PARTSIZE - 1;
		r.stat  = BLOCK_LOCALE;
		r.since = currentTime;
		if (db2 != NULL) Change_range (db2, r);
		return 1; 
		}
	partStatus(akt_part,  false);
	printf("%s [%2u] DEFEKT :-(\n", hash_bin2hex(hash), akt_part); 
	dtype r;
	r.von   = (akt_part+0) * PARTSIZE;
	r.bis   = (akt_part+1) * PARTSIZE - 1;
	r.stat  = 0;
	r.since = currentTime;
//	printf("SET %9u - %9u - %i\n", r.von, r.bis, r.stat);
	if (db2 != NULL) Change_range (db2, r);
	else		printf("No db2 !!!\n");
	Sync();
	return 0;
	}}}
void         sFile::fastCheck (uint32_t VON, uint32_t BIS) {{{
	if(!havePartHash() ) return;		// we can not check anything
	uint32_t VON_PART = VON / PARTSIZE;
	uint32_t BIS_PART = BIS / PARTSIZE;
	for (uint32_t d_check = VON_PART; d_check <= BIS_PART; d_check++)
		if (partDefekt (d_check)) {
			if (checkPart (d_check)) printf("ICH used\n");
			}
	transfered = 0;
	unsigned not_checked = 0;
	dtype new_part;
	for (const dtype *akt_part = firstBlock(); akt_part != NULL; akt_part = nextBlock()) {
		if (!running) return;
		if (akt_part->bis > size) {{{ // size is to big
			memcpy(&new_part, akt_part, sizeof(dtype));
			new_part.bis = size;
			if (new_part.von > new_part.bis ) new_part.von = new_part.bis - 10;
			Change_range (db2, new_part);
			akt_part = &new_part;
			}}}
		if (akt_part->von > akt_part->bis) {{{			// Remove ugly blocks (early versions caused them)
			printf("Warning 265\n");
			if (db2 != NULL) { // DB == NULL compleated
				Print_range(db2);
				deleteBtree (db2, akt_part);
				}
			fflush(stdout);
			ASSERT(0);
			}}}
		ASSERT (akt_part->von <= akt_part->bis);		// Check that there is no "defekt" entry
		if (akt_part->stat != BLOCK_LOCALE) continue;		// Only care about finished blocks
		transfered += (akt_part->bis - akt_part->von + 1);	// Add the transfered byte
		while (true) {
			while (akt_part->von > not_checked * PARTSIZE) not_checked++;
			if ((akt_part->von + 0 <= (not_checked + 0) * PARTSIZE && not_checked * PARTSIZE < size) &&
			    (akt_part->bis + 1 >= (not_checked + 1) * PARTSIZE || akt_part->bis + 1 >= size)) {{{
				if (!running) return;
				if (! partStatus(not_checked)) {		// check it one per runtime
					if (!checkPart (not_checked)) {
						transfered -= PARTSIZE;
						}
					}
				not_checked ++;
				}}}
			else break;
			}
		}
//	printf("%32s Transfered %i\n", hash_bin2hex(hash), transfered);
	}}}
void         sFile::Sync            (void) {{{
	if (fd_in == -1) return;
	if (Completed()) return;
	if (FD_fsync (fd_in ) == 0) return;
	printf("ERROR on fsync(%i) [%s]\n", fd_in, strerror(errno)) ;
	}}}
int          sFile::recvPart        (off_t VON, size_t BIS, const void *data) {{{
	if (db2 == NULL) {
		printf("ERROR(1) recvPart\n");
		return 0;
		}
	if (fd_in < 0) {
		printf("\nERROR: %s -> fd_in < 0\n", __PRETTY_FUNCTION__);
		return 0;
		}
	unsigned von = VON;
	const char *save = (const char *)data;
	if (VON < 0 || von > BIS) {
		printf("\nERROR: %s -> von<0 or von>=bis\n", __PRETTY_FUNCTION__);
		return 0;
		}
	const dtype *POS = Btree_greater_equal (db2, von, 0);
	if (POS == NULL) {
		printf("\nERROR: %s -> POS == NULL (1)\n", __PRETTY_FUNCTION__);
		return 0;
		}
	if (POS->stat == BLOCK_LOCALE && POS->von <= von && POS->bis > von) {{{
		save = save - von + POS->bis;
		von = POS->bis;
		}}}
	POS = Btree_greater_equal (db2, von, 1);	
	if (POS != NULL) {{{
		if (POS->stat == BLOCK_LOCALE && POS->von < BIS) 
			BIS = POS->von - 1;
		}}}
	POS = Btree_greater_equal (db2, von, 4);
	if (POS->bis < size) {
		dtype empty;
		empty.von   = POS->bis + 1;
		empty.bis   = size;
		empty.stat  = 0;
		empty.disk  = 0;
		empty.since = 0;
		Change_range (db2, empty);
		}
	Btree_greater_equal (db2, von, 3);
	if (von >= BIS) {{{
		if (protocol_logLevel < 8) printf("\nINFO doppelt RECV\n");
		return 0;
		}}}
	FD_LSEEK  (fd_in, von, SEEK_SET);
	int len = von - BIS;
	const char *zero = (const char*)save;
	while (len > 0) {
		len--;
		if (*zero != 0) break;
		zero++;
		}
	if (len == 0) {
		printf("\nSpeicher verweigert zero block\n");
		return 1;
		}
	log (1, "RECV %9u-%9u\n", von, BIS);
	size_t do_write = BIS - von;
	FD_WRITE  (fd_in, save, do_write);
	this->dl_count   += do_write;
	this->transfered += do_write;
	dtype r;
	r.von   = von;
	r.bis   = BIS - 1;
	r.stat  = BLOCK_LOCALE;
	r.disk  = 0;
	int ret_chg = Change_range (db2, r);
	if (1 == ret_chg || transfered >= size) fastCheck(r.von, r.bis); 
	if (force_met+60<currentTime) PartMet_write();
	return 1;
	}}}
// Functions need to iterate thorugh all parts
const dtype* sFile::firstBlock      (void) {{{
static dtype full;
	if (db2 == NULL) {
		full.von   = 0;
		full.bis   = size - 1;
		full.stat  = 2000;
		full.disk  = 0;
		full.since = 0;
		return &full;
		}
	const dtype *akt = nextBtree (db2, true);
	if (akt == NULL) return akt;
	if (akt->stat < BLOCK_LOCALE && akt->since + 30*60 < currentTime) {
		dtype change;
		memcpy (&change, akt, sizeof(change));
		change.stat  = 0;
		change.since = currentTime;
		if (change.von > change.bis) 	{
			printf("sFile.cpp 481\n");
			exit(0);
			deleteBtree  (db2, &change);
			}
		else	Change_range (db2, change);
		}
	return akt;
	}}}
const dtype* sFile:: nextBlock      (void) {{{
	if (db2 == NULL) return NULL;
	const dtype *akt = NULL;
	akt = nextBtree (db2, false);
	if (akt == NULL) return akt;
	if (akt->von > akt->bis) deleteBtree (db2, akt);
	if (akt->stat < BLOCK_LOCALE && akt->since + 60 < currentTime) {
		dtype change;
		memcpy(&change, akt, sizeof(change));
		change.stat  = 0;
		change.since = currentTime;
		Change_range (db2, change);
		}
	return akt;
	}}}
// functions needed for gui
void         sFile::calcRate        (time_t diff) {{{
	float ul,dl,d;
	ul = this->ul_count -  ul_last;
	dl = this->dl_count -  dl_last;
	d = diff;
	if (d == 0) d = 1;
	ul_rate = ul_rate * (1.0 - akt_rate_weight) + (ul / d) * akt_rate_weight;
	dl_rate = dl_rate * (1.0 - akt_rate_weight) + (dl / d) * akt_rate_weight;
	if(ul_last!=ul_count || dl_last!=dl_count) {
		if ((currentTime % 60) == 0) log (1, "dt: %2li, dc(%8.2f / %8.2f) , rate(%8.2f / %8.2f)kb/s, c(%10u / %10u)\n",
				diff, dl, ul, dl_rate,ul_rate,this->dl_count,this->ul_count);
		ul_last = ul_count;
		dl_last = dl_count;
		}
	}}}
sFile *forHash (const uint8_t *hash) {{{ // return file that match hash or NULL (unsafe)
	FILE_LIST
		if (0 == memcmp (hash, akt->hash,sizeof(hash)))
			return (sFile*) akt;
	return NULL;
	}}}

