#ifndef sfile_h
#define sfile_h

#include <assert.h>
#include <db.h>
#include "misc.h"
#include "BTree.h"
#define FILE_LIST	for (sFile *akt = sFile::first_file; akt != NULL; akt = akt->next_file)
typedef enum {
	NAME_KNOWN,
	HASHING,
	SOURCE_SEEK,
	SOURCE_KNOWN,
	ALL_DONE
	} eFile_status;

class sFile {
	public:
static	int		 count;			/* total number of current files */
static	int		 count_complete;			/* total number of completed/shared files */
static  class sFile	*first_file;
	class sFile	*next_file;
	tHash	  	 hash;
	time_t		 publish_next;
	time_t		 force_met;
	size_t		 publish_count;
	
	uint32_t  	 part_count;
	tHash	  	*part_hash;
	uint8_t	  	*part_status;
	uint8_t		*part_defekt;
	size_t		*part_sources;

	private:
	void		 PartMet_write (void);
	char	 	*name;
	char		*temp;
	unsigned int	 ul_count;
	unsigned int	 dl_count;
	unsigned int	 ul_last;
	unsigned int	 dl_last;
	double		 ul_rate;
	double		 dl_rate;
	int 		 pause;
	bool		 all_done;		/* file is already completed/ALL_DONE ? */
	unsigned	 dl_prio;
	unsigned	 ul_prio;
	void		 Init  (void);
	void		 Init2 (void);
	bool		 Metfile_load(char *buf, size_t len, const char *dir);
	public:
//	time_t		 kademlia;
	unsigned	 downloads;		// count the dl_hash in sources, updated by changes of dl_hash in sSources
	unsigned	 transfered;
	unsigned int 	 size;
	eFile_status	status;			// faster without extra Call
	unsigned 	 compress_failed;
	DB		*db2;
	unsigned long	 search_count;
const	dtype*		firstBlock	(void); // change "iter"
const	dtype*		 nextBlock	(void); // change "iter"
	int		fd_in;
	 	 sFile (const unsigned char hash[16], const char *name, unsigned int size, const char *dir);
		 sFile (const char *met, const char *dir);
		~sFile (void);
	unsigned int		ulCount		(void) const { return ul_count; }
	unsigned int		dlCount		(void) const { return dl_count; }
	unsigned int		Size 		(void) const { return size; }
	int    			Pause		(void) const { return pause; }
	bool 			Completed	(void) const { return all_done; }
	void 			Completed	(bool new_status ) { all_done = new_status; }
	unsigned		ulPrio		(void) const { return ul_prio; }
	unsigned		dlPrio		(void) const { return dl_prio; }
	void			ulPrio		(unsigned p) { ul_prio  = p; }
	void			dlPrio		(unsigned p) { dl_prio  = p; }
	unsigned int		partCount	(void) const { return part_count; }
	const char *		Name 		(void) const { return name; }
	double			ulRate		(void) const { return ul_rate; }
	double			dlRate		(void) const { return dl_rate; }
	void			calcRate	(time_t diff);

	bool			havePartHash	(void) const { return part_hash != NULL || size <= 9728000; }
	bool			loadPartHash	(void);
	bool			savePartHash	(tHash *hashset);
	tHash*			 getPartHash	(uint32_t i) const;
const	tHash*			listPartHash	(void) const { return part_hash;   }

	bool 			partStatus	(uint32_t idx) const;
	bool 			partDefekt	(uint32_t idx) const;
	void			partStatus	(uint32_t idx, bool set);
	void			partDefekt	(uint32_t idx, bool set);
const	uint8_t*		listPartStatus	(void) const { return part_status; }
const	uint8_t*		listPartDefekt	(void) const { return part_defekt; }

	int			checkPart	(uint32_t part);
	void			fastCheck	(uint32_t von, uint32_t bis);
	int			recvPart	(off_t von, size_t bis, const void *data);

	void			Status		(enum eFile_status s) { status = s; }
	void			ulCount		(unsigned int cnt) { ul_count += cnt; }
	void			Sync		(void);
//	int			SaveStatus 	(void);
	int			Save 		(const char *dir);
	void            	Pause       	(int     p);
friend	sFile *sFile_load            		(const char *name);
	// read config file
//	void readConfig(void);
	};
sFile *forHash (const uint8_t *hash); // return file that match hash or NULL
#endif
