#include <stdio.h>
#include "sPacket.h"
#include "cSocket.h"
#include "protocol.h"
#include "opcodes.h"

int	 sPacket::count = 0;

#define tReadOK	9
void sPacket::Proto (uint8_t p ) {{{
	ASSERT(data != NULL);
	*((uint8_t *)(data + 0)) = proto = p;
	}}}
void sPacket::Paylen(size_t p ) {{{
	ASSERT(data != NULL);
	*((uint32_t*)(data + 1)) = pay_len = (uint32_t)p;
	}}}
void sPacket::Opcode(uint8_t p ) {{{
	ASSERT(data != NULL);
	*((uint8_t *)(data + 5)) = opcode = p;
	}}}
sPacket            ::sPacket  (uint8_t cmd, size_t Size) {{{
	size   = 6 + Size;
	data = (char*)MALLOC (size);
	Proto(OP_EDONKEYHEADER);
	Paylen(Size + 1);
	Opcode(cmd);
	pos = 0;
//	next = NULL ;
	count++;
	status  = 100;
	if (pay_len - 1 == pos) status = 101;
	}}}
sPacket            ::sPacket  () {{{
	size = 0;
	count++;	
	data = NULL;
	status  = 0;
	pos = 0;
//	next = NULL ;
	}}}
sPacket            ::~sPacket (void) {{{
	if (status != 103 && status >= 101) {
		printf("sPacket status %i\n", status);
		fflush(stdout);
		ASSERT(0);
		}
	if (data != NULL) Free2 (data);
	count--;
	}}}
int         sPacket::Read     (class cSocket *Socket) {{{
	ASSERT (Socket != NULL);
	ASSERT(Socket->validSocket());
	ASSERT (status != -1);
	if (status <= 0) {{{ // Lese Header vorbereiten
		pos = 6;
		size = 6;
		if (data != NULL) Free2(data);
		data = (char*)MALLOC  (size);
		ASSERT (data != NULL);
		Proto (0);
		status = 1;
		}}}
	if (status == 1) {{{
		size_t ret = Socket->Read (data + 6 - pos, pos);	// never return - value
		pos -= ret;
		if (pos > 0) return 0;
		proto   = *((uint8_t *)(data + 0));
		pay_len = *((uint32_t*)(data + 1));
		opcode  = *((uint8_t *)(data + 5));
		if (proto != OP_EDONKEYHEADER && proto != 0xD4 && proto != 0xC5) { 
			Socket->Close();
			status = -1;
			return -1;
			}
		status = (pay_len == 1)?tReadOK:2;
		if (status == tReadOK) return 0;
		size = 5 + pay_len;
		if (size > 200000) {{{ // Limit packet size
			Socket->Close();
			status = 3;
			return 0;
			}}}
		data = (char*)REALLOC (data, size);
		}}}
	if (status == 2) {{{ // Lese Daten
		size_t missing = pay_len - pos - 1;
		size_t ret = Socket->Read (data + 6 + pos, missing);	// never return - value
		if (ret == 0) return  0;
		pos += ret;
		if (pos == pay_len - 1) {
			pos = 0;
			status = tReadOK;
			return 1;
			}
		}}}
	return 0;				// Solte nie hier ankommen
	}}}
int         sPacket::Send     (class cSocket *Socket) {{{
	ASSERT (Full());	
	ASSERT (Socket != NULL);
	ASSERT (status == 101);
	ASSERT(Socket->validSocket());
	Socket->Write (data, size); // -2 (-1 Byte wegen array[1] und Code ist im Header)
	status = 103;
	return 1;
	}}}
bool        sPacket::ADD_HASH (const uint8_t *val) {{{
	ASSERT (100 == status );
	ASSERT (data != NULL);
	ASSERT (pay_len - pos >= 16);
	memcpy (data + 6 + pos , val, 16); 
	pos += 16;
	if (pos == pay_len- 1 ) status = 101;
	return true;
	}}}
bool        sPacket::ADD_F4   (float val) {{{
	ASSERT (100 == status );
	ASSERT (data != NULL);
	ASSERT (pay_len - pos >= sizeof (val));
	memcpy(data + 6 + pos, &val, sizeof(val));
	pos += sizeof(val);
	if (pay_len - 1 == pos) status = 101;
	return true;
	}}}
bool        sPacket::ADD_U4   (uint32_t val) {{{
	ASSERT (100 == status );
	ASSERT (data != NULL);
	ASSERT (pay_len - pos >= sizeof (val));

	uint32_t *VAL = ((uint32_t*)(6 + data + pos));
	*VAL = ctol32 (val);
	pos += sizeof(val);
	if (pay_len - 1 == pos) status = 101;
	return true;
	}}}
bool        sPacket::ADD_U2   (uint16_t val) {{{
	ASSERT (100 == status );
	ASSERT (data != NULL);
	ASSERT (pay_len - pos >= sizeof (val));
	memcpy (data + 6 + pos, &ctol16 (val), sizeof(val));
	pos += sizeof(val);
	if (pay_len - 1 == pos) status = 101;
	return true;
	}}}
bool        sPacket::ADD_U1   (uint8_t  val) {{{
	ASSERT (100 == status );
	ASSERT (data != NULL);
	ASSERT (pay_len - pos >= sizeof (val));
	memcpy (data + 6 + pos, &        val , sizeof(val));
	pos += sizeof(val);
	if (pay_len - 1 == pos) status = 101;
	return true;
	}}}
bool        sPacket::ADD_S2   (const    char  *val) {{{
	ASSERT (100 == status );
	ASSERT (data != NULL);
	ASSERT (val    != NULL);
	ASSERT (pay_len - pos >= strlen (val) + 2);
	/* adding length to ed2k packet */
	size_t len = strlen(val);
	ASSERT(len < 0x10000);
	if  (! ADD_U2 ((uint16_t)len)) return false;
	memcpy (data + 6 + pos, val, strlen(val));
	pos += strlen(val);
	if (pay_len - 1 == pos) status = 101;
	return true;
	}}}
bool	       sPacket::ADD_DATA	(const char *val,size_t len) {{{
	ASSERT (100 == status );
	ASSERT (data != NULL);
	ASSERT (val    != NULL);
	ASSERT (pay_len - pos >= len);
	memcpy (data + 6 + pos, val, len);
	pos += len;
	if (pay_len - 1 == pos) status = 101;
	return true;
	}}}
bool	       sPacket::ADD_BLIND(uint32_t len) {{{
	ASSERT (100 == status   );
	ASSERT (data != NULL);
	ASSERT (pay_len - pos >= len);
	pos += len;
	if (pay_len - 1 == pos) status = 101;
	return true;
	}}}

bool        sPacket::GET_HASH (tHash &dst) {{{
	ASSERT (tReadOK == status);
	ASSERT (pay_len - pos >= sizeof(tHash));
	ASSERT (dst != NULL);
	memcpy (dst, data + 6 + pos, sizeof(tHash));
	pos += sizeof(tHash); 
	return true;
	}}}
float       sPacket::GET_F4   (void) {{{
	float    val = 0;
	ASSERT (tReadOK == status);
	ASSERT (pay_len - pos >= sizeof (val));
	memcpy (&val, data + 6 + pos, sizeof(val));
	pos += sizeof(val); 
	return val;
	}}}
uint32_t    sPacket::GET_U4   (void) {{{
	uint32_t val = 0;
	ASSERT (tReadOK == status);
	ASSERT (pay_len - pos >= sizeof (val));
	memcpy (&val, 6 + data + pos, sizeof(val));
	pos += sizeof(val); 
	return ctol32(val);
	}}}
uint16_t    sPacket::GET_U2   (void) {{{
	uint16_t val = 0;
	ASSERT (tReadOK == status);
	ASSERT (pay_len - pos >= sizeof (val));
	memcpy (&val, 6 + data + pos, sizeof(val));
	pos += sizeof(val); 
	return ctol16(val);
	}}}
uint8_t     sPacket::GET_U1   (void) {{{
	uint8_t  val = 0;
	ASSERT (tReadOK == status);
	ASSERT (pay_len - pos >= sizeof (val));
	memcpy (&val, 6 + data + pos, sizeof(val));
	pos += sizeof(val); 
	return val;
	}}}
char*       sPacket::GET_S2   (void) {{{
	uint16_t Size = GET_U2 ();
	ASSERT (tReadOK == status);
	if(Size == 0) return STRDUP ("");
	char *val = (char*)MALLOC (Size + 1);
	memcpy (val, data + 6 + pos, Size);
	val[Size] = 0;
	pos += Size;
	return val;
	}}}
void        sPacket::GET_BLIND(unsigned len) {{{
	ASSERT (tReadOK == status);
	ASSERT (pay_len - pos >= len);
	pos += len;
	}}}
void*       sPacket::DATA     (void) {{{
	return data + 6 + pos; 
	}}}
void        sPacket::Dump     (void) const {{{
//	ASSERT(0);
	printf("\r\nprotokol:%02x\r\n", proto);
	printf("length    : %u\r\n"   , pay_len);
	printf("position  : %#08X\r\n", pos);
	unsigned tmp = opcode;
	printf("command   : 0x%02hx\r\n", tmp);
	for (uint32_t i=0; i < pay_len - 1; i++) {
		if(i%16==0) printf("\r\n%#08X ", i);
		tmp = (unsigned char)data[6+i];
		printf ("%02hx ", tmp);
		}
	printf("\r\n");
	}}}
bool        sPacket::readReset(void) {{{
	if (status != tReadOK) {
		printf("Status %i\r\n", status);
		fflush(stdout);
		}
	ASSERT (status == tReadOK);
	ASSERT (pos = pay_len);
	status = 0;
	pos = 0;
	return true;
	}}}
/*
 * vim600: fdm=marker
 */
